Page MenuHomePhabricator

Remove "midi" option
Closed, DeclinedPublic

Description

There are a number of problems with the "midi" attribute:

  • The midi file is not discoverable, and is provided by a magic link wrapping the score image itself
  • Users may click on the score expecting the image gallery viewer, but instead get a download they didn't want
  • We now provide vorbis renderings with an embedded player, which solves the problem of letting the user hear the music.
  • Editors may be confused about which options to provide

I assume the reason we still have this feature is just legacy from before vorbis support was added. The user need (to hear the music) is much better satisfied by the vorbis feature.

The only reasons I can think of to keep midi support would be

  • For MW users who want to have score and audio rendering, but don't want to install TimedMediaHandler/vorbis libraries. I imagine such users don't exist. I don't believe we need to support it.
  • For Wikipedia users who see a score rendering and really want the midi for some advanced usage. I imagine such use cases to be extremely low and such advanced users could extract the lilypond from source and generate the midi themselves.

Removing the midi link option would allow us to re-purpose the action of clicking on the score to something more useful, such as showing a higher resolution rendering, showing the lilypond code, triggering the vorbis player etc...

Event Timeline

Esanders created this task.Oct 6 2015, 1:58 PM
Esanders raised the priority of this task from to Needs Triage.
Esanders updated the task description. (Show Details)
Esanders added a subscriber: Esanders.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 6 2015, 1:58 PM
Esanders updated the task description. (Show Details)Oct 6 2015, 2:02 PM
Esanders set Security to None.
Esanders added subscribers: TrevorParscal, Tchanders.
Krenair added a subscriber: Krenair.Oct 6 2015, 2:32 PM

Script to see all uses of <score> tag on a wiki: P2159

I would support moving the MIDI file link to a lower-visibility affordance, such as a small icon or text link with a "Download MIDI file" tooltip or label respectively. I'm biased toward not wanting to dispense with this neat functionality because, as Ed put it, I've "actually used a synthesizer before". Nonetheless, if we can just make it far less prominent I think that would be a good balance.

Restricted Application added a subscriber: StudiesWorld. · View Herald TranscriptJan 25 2016, 10:40 PM
Ebe123 added a subscriber: Ebe123.

It is true that the current link-wrapping is odd, especially that scores with MIDI is only available arbitrarily; only based on the preference/knowledge of the typesetter. I agree with @TrevorParscal where midi should be available in a tooltip or similar. Going further, it may be an idea to make midi and vorbis enabled by default. Other opinions?

mb added a subscriber: mb.Dec 10 2017, 12:21 AM

Change 400202 had a related patch set uploaded (by Ebe123; owner: Ebe123):
[mediawiki/extensions/Score@master] Add DOM Structure to Scores

https://gerrit.wikimedia.org/r/400202

Ebe123 added a comment.EditedDec 26 2017, 2:26 AM

I like the idea of showing the code when clicking on the score. With that interface, the sheet music could still be shown with more focus than on the page, but would also allow for the more "advanced" features such as showing the score code and the MIDI file. Combined with a syntax highlighter (SyntaxHighlight?) and linter, it would be amazing. Adding more structure to the rendered HTML would be a first step towards this.

Change 400202 abandoned by Ebe123:
Add DOM Structure to Scores

Reason:
We have Albert221's patch that also constructs structure.

https://gerrit.wikimedia.org/r/400202

Krinkle removed a project: Proposal.
Ebe123 closed this task as Resolved.Dec 31 2017, 12:36 AM
Ebe123 claimed this task.

It's been removed.

Krinkle changed the task status from Resolved to Declined.Dec 31 2017, 12:37 AM
Krinkle added a subscriber: Krinkle.

Declining this task per T183736. It essentially resolved the original user-experience problem similar to how it was suggested by Ed and Trevor (move to link in a tooltip, instead of as primary link target, and enable by default, obsoleting the midi attribute).